<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<!-- <link rel="import" href="/extern/bower_components/paper-button/paper-button.html"> -->

<!--
`ajaxell-menu` is the element that generates the sidebar in AjaXell cells.

Example:

    <ajaxell-menu menu="..."></ajaxell-menu>

The menu object should look something like this:

    {
      "menu": [
        {
          "name": "first main menu"
          "menu": [
            {
              "name": "first subitem",
              "name": "second subitem",
              "name": "third subitem",
              "menu": [
                "name": "a sub-subitem"
              ]
            }
          ]
        },
        {
          "name": "second main menu"
          "menu": [
            {
              "name": "first subitem",
              "name": "second subitem",
              "name": "third subitem",
              "menu": [
                "name": "a sub-subitem"
              ]
            }
          ]
        }
      ]
    }

-->
<dom-module id="ajaxell-menu">
  <template>
    <style>
a,p{font-family:Roboto,Noto,sans-serif;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility;font-size:.8em}a{display:block;text-decoration:none;color:black;padding-top:5px;padding-bottom:5px}p{font-weight:bold;border-top:1px solid #E0E0E0;margin:0;padding-top:10px;padding-bottom:10px}p[closed] iron-icon{height:20px;transform:rotate(0deg)}p[open] iron-icon{height:20px;transform:rotate(90deg)}p iron-icon{transition:transform 400ms;margin-right:1em;--iron-icon-fill-color:var(--primary-color-light-30)}p span[warning]{color:red;padding-left:10px}:host([closed])>#container{max-height:0;opacity:0;pointer-events:none;cursor:default}#container{max-height:1000px;opacity:1;transition:max-height .5s ease-out, opacity .3s ease-in-out}#container>a:last-child{padding-bottom:10px}:host([recursion-level="0"]) p,:host([recursion-level="0"]) a{padding-left:16px}:host([recursion-level="1"]) p,:host([recursion-level="1"]) a{padding-left:32px}:host([recursion-level="2"]) p,:host([recursion-level="2"]) a{padding-left:48px}:host([recursion-level="3"]) p,:host([recursion-level="3"]) a{padding-left:64px}:host([recursion-level="4"]) p,:host([recursion-level="4"]) a{padding-left:80px}

</style>

    <div id="container">

    </div>

  </template>
  <script>
Polymer({is:"ajaxell-menu",properties:{menu:{type:Object,observer:"_menuChanged"},recursionLevel:{type:Number,value:0,reflectToAttribute:!0},recursionRootName:{type:String,value:""},closed:{type:Boolean,value:!0,reflectToAttribute:!0}},toggle:function(){this.closed=!this.closed},attached:function(){0==this.recursionLevel&&(this.closed=!1)},_menuChanged:function(){var root=Polymer.dom(this.$.container);root.innerHTML="";for(var i=0;i<this.menu.length;i++){var currentMenu=this.menu[i];if("Home"!=currentMenu.name)if(currentMenu.menu||0==this.recursionLevel){var title=document.createElement("p"),icon=document.createElement("iron-icon");if(0==this.recursionLevel?icon.icon="ajaxell:"+currentMenu.name.toLowerCase().replace(" ","-"):(icon.icon="icons:chevron-right",title.setAttribute("closed","closed")),title.appendChild(icon),title.appendChild(document.createTextNode(currentMenu.name)),title.addEventListener("click",function(){this.getAttribute("closed")?(this.removeAttribute("closed"),this.setAttribute("open","open")):this.getAttribute("open")&&(this.removeAttribute("open"),this.setAttribute("closed","closed")),this.nextSibling.toggle()}),!currentMenu.menu){var warning=document.createElement("span");warning.setAttribute("warning","warning"),warning.appendChild(document.createTextNode("(empty)")),title.appendChild(warning)}root.appendChild(title);var submenu=document.createElement("ajaxell-menu");switch(submenu.recursionLevel=this.recursionLevel+1,0==this.recursionLevel?submenu.recursionRootName=currentMenu.name:submenu.recursionRootName=this.recursionRootName,currentMenu.name){case"Commands":case"Peers":submenu.closed=!1}root.appendChild(submenu),submenu.menu=currentMenu.menu}else{var link=document.createElement("a");"Monitoring"==this.recursionRootName&&0==currentMenu.name.indexOf("urn:xdaq-flashlist:")?link.textContent=currentMenu.name.substring(19):link.textContent=currentMenu.name,currentMenu.url?(link.href=currentMenu.url,link.target="_blank"):link.href="#!/"+this.recursionRootName.split(" ").join("%20")+"/"+currentMenu.name.split(" ").join("%20"),root.appendChild(link)}}}});
</script>
</dom-module>
